import greenfoot.*;

public class Beine extends Actor
{    
    int animationcounter;
    boolean letzterichtung;
    int block = 0;
    
    //Bilder des Spielers
    private GreenfootImage bild1;
    private GreenfootImage bild2;
    private GreenfootImage bild3;
    private GreenfootImage bild4;
    
    //Variablen fr die "Physik" des Spiels
    private int speed = 7;
    private int vSpeed = 0;
    private int acceleration = 1;
    private int jumpStrength = 15;
    private boolean jumping = false;
    private int floor;
    private int reduceCollisionDetection = 3;
    private int currCollDetection = 0;
    public void act()
    {
        dieBewegung();
        fallUeberpruefen();
        
        //Bilder werden Variablen zugewiesen
        bild1 = new GreenfootImage("spieler_hosec.png");
        bild2 = new GreenfootImage("spieler_hose2c.png");
        bild3 = new GreenfootImage("spieler_hose3c.png");
        bild4 = new GreenfootImage("spieler_hose4c.png");
    }

    public void dieBewegung()
    {
        if(block == 0) //Spieler bewegt sich nicht horizonal durch "Boden"-Klassen
        {
            if (Greenfoot.isKeyDown("a")) //Bewegung nach links
            {
                if (!(checkLeft()) || vSpeed < 0)
                {
                    moveLeft();
                }
            }
            
            if (Greenfoot.isKeyDown("d")) //Bewegung nach rechts
            {
                if (!(checkRight()) || vSpeed < 0)
                {
                    moveRight();
                }
            }
            
            if (Greenfoot.isKeyDown("space") && jumping==false) //Springen
            {
                jump();
            }
            
            if(xDirection() == true) //Prfen ob die Maus weiter links oder rechts als der Spieler ist
            {
                if(Greenfoot.isKeyDown("a") == true || Greenfoot.isKeyDown("d") == true) //Bewegungsanimation
                {
                    linksAnimation();
                }
            }
            else
            {
                if(Greenfoot.isKeyDown("a") == true || Greenfoot.isKeyDown("d") == true) //Bewegungsanimation
                {
                    rechtsAnimation();
                }
            }
            
            if(xDirection() == true) //Prfen ob die Maus weiter links oder rechts als der Spieler ist
            {
                if(Greenfoot.isKeyDown("a") == true && Greenfoot.isKeyDown("d") == true) //Wenn man den "Links"- und "Rechts"-Knopf drcht wird keine Animation erscheinen
                {
                    setImage(bild2);
                }
            }
            else
            {
                if(Greenfoot.isKeyDown("a") == true && Greenfoot.isKeyDown("d") == true) //Wenn man den "Links"- und "Rechts"-Knopf drcht wird keine Animation erscheinen
                {
                    setImage(bild1);
                }
            }
            
            if(xDirection() == true) //Prfen ob die Maus weiter links oder rechts als der Spieler ist
            {
                if(Greenfoot.isKeyDown("a") == false && Greenfoot.isKeyDown("d") == false) //Keine Animation wenn der Spieler still steht
                {
                    setImage(bild2);
                }
            }
            else
            {
                if(Greenfoot.isKeyDown("a") == false && Greenfoot.isKeyDown("d") == false) //Keine Animation wenn der Spieler still steht
                {
                    setImage(bild1);
                }
            }
        }
        else
        {}
    }
    
    public void fallUeberpruefen() //berprft ob der Spieler Boden unter den Fen hat
    {
        if(onGround()) {
            vSpeed = 0;
            jumping = false;
        }
        else {
            fall();
        }
    }
    
    public void fall() //Fall der Spielers (wird zunehmend schneller)
    {
        setLocation ( getX(), getY() + vSpeed);
        vSpeed = vSpeed + acceleration;
    }
    
    public boolean onGround() //Boolean zum berprfen ob der Spieler auf Boden steht
    {
        Boden under = null;
        int counter = 1;
        int max = vSpeed;
        while (counter <= max && under == null)
        {
            under = (Boden)getOneObjectAtOffset ( 0, getImage().getHeight() / 2 + counter, Boden.class);
            counter++;
        }
        return under != null;
    }
    
    public void moveRight() //Spieler bewegt sich nach rechts
    {
        if(block == 0)
        {
            setLocation ( getX() + speed, getY() );
        }
        else
        {}
    }

    public void moveLeft() //Spieler bewegt sich nach links
    {
        if(block == 0)
        {
            setLocation ( getX() - speed, getY() );
        }
        else
        {}
    }
    
    public void jump() //Spieler springt
    {
        jumping = true;
        vSpeed = -jumpStrength;
        fall();
    }
    
    public boolean checkLeft() //berprft ob links vom Spieler eine "Boden"-Klasse ist
    {
        Actor bumper = null;
        int counter = 0;
        int max = (int)(getImage().getHeight() / 2);
        while (counter < max && bumper == null)
        {
            bumper = getOneObjectAtOffset (-1*( getImage().getWidth() / 2), max - counter, Boden.class);
            counter++;
        }
        return bumper != null;
    }

    public boolean checkRight() //berprft ob rechts vom Spieler eine "Boden"-Klasse ist
    {
        Actor bumper = null;
        int counter = 0;
        int max = (int)(getImage().getHeight() / 2);
        while (counter < max && bumper == null)
        {
            bumper = getOneObjectAtOffset ( getImage().getWidth() / 2, max - counter , Boden.class);
            counter++;
        }
        return bumper != null;
    }
    
    public boolean xDirection() //Prft ob die Maus links oder rechts vom Spieler ist (Bild spiegelt sich wenn true, ist die Maus nicht auf dem Spielfeld, wird die letzte Richtung gemerkt)
    {
        MouseInfo info = Greenfoot.getMouseInfo();
        if(info == null)
        {
            if(letzterichtung == true)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        else if(info.getX() < getX())
        {
            letzterichtung = true;
            return true;
        }
        else
        {
            letzterichtung = false;
            return false;
        }
    }
    
    public void linksAnimation() //Wechsel zwischen zwei Bilder, das zu einer Animation fhrt (links)
    {
        animationcounter++;
        if(animationcounter > 8)
        {
            setImage(bild4);
            if(animationcounter > 16)
            {
                setImage(bild2);
                animationcounter = 0;
            }
        }
    }
    
    public void rechtsAnimation() //Wechsel zwischen zwei Bilder, das zu einer Animation fhrt (rechts)
    {
        animationcounter++;
        if(animationcounter > 8)
        {
            setImage(bild3);
            if(animationcounter > 16)
            {
                setImage(bild1);
                animationcounter = 0;
            }
        }
    }
}
    

