import greenfoot.*;
import java.util.List;

public class GegnerMesser extends Gegner
{
    //Bilder des Gegners
    private GreenfootImage bild1;
    private GreenfootImage bild2;
    private GreenfootImage bild3;
    private GreenfootImage bild4;
    
    int animationcounter; //Geschwindigkeit der Animation
    boolean sperre = false; //Sperre der "KI" (Wenn der Gegner z.B. auf dem Kran ist soll er nur nach rechts gehen und nicht dem Spieler folgen)
    int ende = 0; //Stoppt bei "1" das Spiel
    int leben = 6; //Anzahl der Schsse, die der Gegner aushlt
    
    //Variablen fr die "Physik" des Spiels
    int speed = 4;
    private int vSpeed = 0;
    private int acceleration = 1;
    private int jumpStrength = 15;
    private boolean jumping = false;
    private int floor;
    private int reduceCollisionDetection = 3;
    private int currCollDetection = 0;
    
    public void act() 
    {
        //Bilder werden Variablen zugewiesen
        bild1 = new GreenfootImage("gegner1c.png");
        bild2 = new GreenfootImage("gegner2c.png");
        bild3 = new GreenfootImage("gegner3c.png");
        bild4 = new GreenfootImage("gegner4c.png");
        
        spielerToeten();
        fallUeberpruefen();
        ki();
        sterben();
    }
    
    public boolean onGround() //Boolean zum berprfen ob der Gegner auf Boden steht
    {
        Boden under = null;
        int counter = 1;
        int max = vSpeed;
        while (counter <= max && under == null)
        {
            under = (Boden)getOneObjectAtOffset ( 0, getImage().getHeight() / 2 + counter, Boden.class);
            counter++;
        }
        return under != null;
    }
    
    public void fallUeberpruefen() //berprft ob der Gegner Boden unter den Fen hat
    {
        if(onGround()) {
            vSpeed = 0;
            jumping = false;
        }
        else {
            fall();
        }
    }
    
    public void fall() //Fall der Spielers (wird zunehmend schneller)
    {
        setLocation ( getX(), getY() + vSpeed);
        vSpeed = vSpeed + acceleration;
    }
    
    public boolean checkLeft() //berprft ob links vom Gegner eine "Boden"-Klasse ist
    {
        Actor bumper = null;
        int counter = 0;
        int max = (int)(getImage().getHeight() / 2);
        while (counter < max && bumper == null)
        {
            bumper = getOneObjectAtOffset (-1*( getImage().getWidth() / 2), max - counter, Boden.class);
            counter++;
        }
        return bumper != null;
    }

    public boolean checkRight() //berprft ob rechts vom Gegner eine "Boden"-Klasse ist
    {
        Actor bumper = null;
        int counter = 0;
        int max = (int)(getImage().getHeight() / 2);
        while (counter < max && bumper == null)
        {
            bumper = getOneObjectAtOffset ( getImage().getWidth() / 2, max - counter , Boden.class);
            counter++;
        }
        return bumper != null;
    }
    
    public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;        
    }
    
    public void moveRight() //Gegner bewegt sich nach rechts
    {
        setLocation ( getX() + speed, getY() );
    }

    public void moveLeft() //Gegner bewegt sich nach links
    {
        setLocation ( getX() - speed, getY() );
    }
    
    public void jump() //Gegner springt
    {
        jumping = true;
        vSpeed = -jumpStrength;
        fall();
    }
    
    public void ki() //Pathfinding der Gegner
    {
        int spielerX = ((Beine) getWorld().getObjects(Beine.class).get(0)).getX();
        int spielerY = ((Beine) getWorld().getObjects(Beine.class).get(0)).getY();
        if (spielerY < getY() && (checkRight()) || (checkLeft()))
        {
            jump();
        }
        
        if(getY() < 170 && getY() > 80)
        {
            moveLeft();
            linksAnimation();
            sperre = true;
        }
        else if(spielerX < getX() && sperre == false)
        {
            moveLeft();
            linksAnimation();
        }
        else
        {
            sperre = false;
        }
        
        if(getY() < 50)
        {
            moveRight();
            rechtsAnimation();
            sperre = true;
        }
        else if(spielerX > getX() && sperre == false)
        {
            moveRight();
            rechtsAnimation();
        }
        else
        {
            sperre = false;
        }
        
        if(getX() < 600 && spielerX < 460 && getY() > 120)
        {
            if(spielerY < 300 && getY() > 300 && getY() != 382)
            {
                moveRight();
                rechtsAnimation();
                sperre = true;
            }
            else if(spielerY > 300 && getY() < 300 && getY() > 120 && getY() != 382)
            {
                moveRight();
                rechtsAnimation();
                sperre = true;
            }
            else
            {
                sperre = false;
            }
        }
    }
    
    public void linksAnimation() //Wenn sich der Gegner nach links bewegt, wird diese Animation ausgefhrt
    {
        animationcounter++;
        if(animationcounter > 8)
        {
            setImage(bild4);
            if(animationcounter > 16)
            {
                setImage(bild2);
                animationcounter = 0;
            }
        }
    }
    
    public void rechtsAnimation() //Wenn sich der Gegner nach links bewegt, wird diese Animation ausgefhrt
    {
        animationcounter++;
        if(animationcounter > 8)
        {
            setImage(bild3);
            if(animationcounter > 16)
            {
                setImage(bild1);
                animationcounter = 0;
            }
        }
    }
    
    public void spielerToeten()
    {
        if(canSee(Koerper.class))
        {
            ((Koerper)getWorld().getObjects(Koerper.class).get(0)).getroffen();
        }
    }
    
    public void lebenVerlieren()
    {
        leben = leben - 1;
    }
    
    public void sterben()
    {
        if(leben < 1)
        {
            ((KillCounter)getWorld().getObjects(KillCounter.class).get(0)).bumpCount(1);
            getWorld().removeObject(this);
        }
    }
}